<?php

// phpMyDoc - MySQL Documenter
// Copyright (C) 2001-2002  Justin Streufert
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

// Appearance

define('kPMD_DialogNothing', 0);
define('kPMD_DialogContinue', 1);

function pmd_lm($msgname, $replace = array(), $language = kPMD_Language)
{
   // Localize Message
   // 
   // Grabs the requested message by key ($msgname) in the current locale
   // or the one specified by the two letter code in $language. Replaces
   // uppercase keys surrounded by curly brackets with appropriate values
   // using the array specified in $replace. Example:
   // 
   // $replace = array(
   //    'version' => '1.2.3'
   //    'name' => 'George'
   // );
   // 
   // If the message is:
   // "Version {VERSION} by {NAME}"
   // It will turn out as:
   // "Version 1.2.3 by George"
   
   $msgloc = 'pmd_messages_' . $language;
      
   if(isset($GLOBALS[$msgloc][$msgname])) {
      $msg = $GLOBALS[$msgloc][$msgname];
      reset($replace);
      for($x=0;$x!=count($replace);$x++) {
	 $msg = str_replace('{' . strtoupper(key($replace)) . '}',
			    current($replace), $msg);
	 next($replace);
      }
      return $msg;
   } else {
      if($language == 'en') {
	 return "[Missing Message $msgname]";
      } else {
	 // Fall back to English
	 return '[en]' . pmd_lm($msgname, $replace, 'en');
      }
   }
}

function f($style = 'n')
{
   // Returns a font tag
   // 
   // style - determines which font is returned
   
   $fonts = Array('s' => 
		  '<FONT SIZE=1 FACE="Tahoma, Verdana, Arial, Helvetica">',
		  'n' =>
		  '<FONT SIZE=2 FACE="Arial, Helvetica, Tahoma, Verdana">',
		  'l' =>
		  '<FONT SIZE=3 FACE="Tahoma, Verdana, Arial, Helvetica">');
   return($fonts[$style]);		  
}

function linkify($text, $exclude = '', $linkbase = 'doc.php?table=')
{
   $dbq = db_q("show tables");
   $dbc = dbcount($dbq);
   
   $tables = Array();
   for($x=0; $x!=$dbc; $x++) {
      list($tables[]) = dbrow($dbq, $x);
   }
   
   usort($tables, 'size_cmp');
   
   for($x=0; $x!=$dbc; $x++) {
      $table = $tables[$x];
      
      // We munge the table name to prevent re-replacement (and
      // corruption) that happens if table names contain other table names.
      $table_munged = '';
      for($t=0; $t!=strlen($table); $t++) {
	 $table_munged .= substr($table, $t, 1);
	 $table_munged .= '#####Munge#####';
      }
      
      if($table != $exclude) $text =
	preg_replace("/([^a-zA-Z])$table([^a-zA-Z0-9_])/",
		     "\\1<A HREF=\"$linkbase$table_munged\">$table_munged</A>\\2",
		     $text);
   }
   return str_replace('#####Munge#####', '', $text);
}

function show_dialog($title, $html, $kind = kPMD_DialogNothing,
		     $varname = 'PMDDialogResult', $rememberVars = Array())
{
   // rememberVars is here for the future but is not implemented
   echo '<HTML><HEAD><TITLE>' . $title . '</TITLE></HEAD>';
   echo '<BODY BGCOLOR="#FFFFFF">';
   echo '<TABLE CELLSPACING=0 CELLPADDING=0 BORDER=0 WIDTH="100%" HEIGHT="98%">';
   echo '<TR><TD VALIGN=MIDDLE ALIGN=CENTER>';
   echo '<TABLE WIDTH=600 CELLPADDING=5 CELLSPACING=0 BORDER=0>';
   echo '<TR><TD BGCOLOR="#DDDDDD">' . f('l') . '<B>phpMyDoc: ' . $title . '</B></FONT></TD></TR>';
   echo '<TR><TD BGCOLOR="#EEEEEE">' . f() . $html . '</FONT></TD></TR>';
   switch($kind) {
    case kPMD_DialogContinue:
      echo "<TR><TD BGCOLOR=\"#EEEEEE\"><CENTER><FORM METHOD=POST><INPUT TYPE=SUBMIT NAME=" .
	"$varname VALUE=" . pmd_lm('continue') . "></CENTER></TD></TR>";
      break;
   }
   echo '</TABLE>';
   echo '</TD></TR></TABLE>';
   echo '</BODY></HTML>';
}

?>
